#include "BarrageManager.h"
#include "sprite.h"
#include "Bullet.h"
#include "Utils.h"

const fix16 bullet3[3 * 2] =
    {
        FIX16(-1), 0,
        0, FIX16(-1),
        FIX16(1), 0};
const fix16 bullet5[5 * 2] =
    {
        FIX16(-1), 0,
        FIX16(-0.7), FIX16(-0.7),
        0, FIX16(-1),
        FIX16(0.7), FIX16(-0.7),
        FIX16(1), 0};
const fix16 bullet10[10 * 2] =
    {
        FIX16(-1),
        0,
        FIX16(-0.9),
        FIX16(-0.34),
        FIX16(-0.77),
        FIX16(-0.6),
        FIX16(-0.5),
        FIX16(-0.9),
        FIX16(-0.2),
        FIX16(-0.9),
        FIX16(0.2),
        FIX16(-1),
        FIX16(0.5),
        FIX16(-0.9),
        FIX16(0.8),
        FIX16(-0.6),
        FIX16(0.9),
        FIX16(-0.3),
        FIX16(1),
        0,
};

void BarrageManager_CreateBarrage(enum BARRAGE_TYPE type, ObjectStruct *object)
{
    //u8 randDirection = random() % 2;
    fix16 halfWidth = intToFix16(object->sprite->frame->w >> 1);
    fix16 halfHeight = intToFix16(object->sprite->frame->h >> 1);
    fix16 x = object->x + halfWidth;
    fix16 y = object->speedY < 0 ? object->y : object->y + halfHeight;
    switch (type)
    {
    case SHOOT3x:
        for (u8 i = 0; i < 3; i++)
        {
            ObjectStruct *bullet = BulletCreate(x, y);
            if (bullet)
            {
                bullet->maxSpeedX = bullet3[i << 1] << 2;
                bullet->maxSpeedY = bullet3[(i << 1) + 1] << 2;
                bullet->maxSpeedY = object->speedY < 0 ? bullet->maxSpeedY : -bullet->maxSpeedY;
                bullet->flags = object->flags;
            }
        }
        break;
    case SHOOT6x:
        for (u8 i = 0; i < 5; i++)
        {
            ObjectStruct *bullet = BulletCreate(x, y);
            if (bullet)
            {
                bullet->maxSpeedX = bullet5[i << 1] << 2;
                bullet->maxSpeedY = bullet5[(i << 1) + 1] << 2;
                bullet->maxSpeedY = object->speedY < 0 ? bullet->maxSpeedY : -bullet->maxSpeedY;
                bullet->flags = object->flags;
            }
        }
        break;
    case SHOOT9x:
        for (u8 i = 0; i < 10; i++)
        {
            ObjectStruct *bullet = BulletCreate(x, y);
            if (bullet)
            {
                bullet->maxSpeedX = bullet10[i << 1] << 2;
                bullet->maxSpeedY = bullet10[(i << 1) + 1] << 1;
                bullet->maxSpeedY = object->speedY < 0 ? bullet->maxSpeedY : -bullet->maxSpeedY;
                bullet->flags = object->flags;
            }
        }
        break;
    default:
        for (u8 i = 0; i < 1; i++)
        {
            ObjectStruct *bullet = BulletCreate(x, y);
            if (bullet)
            {
                bullet->maxSpeedX = 0;
                bullet->maxSpeedY = FIX16(4);
                bullet->maxSpeedY = object->speedY > 0 ? bullet->maxSpeedY : -bullet->maxSpeedY;
                bullet->flags = object->flags;
            }
        }
        break;
    }
}