#include <genesis.h>
#include "Constants.h"
#include "Utils.h"
#include "AllObjects.h"
#include "Player.h"
#include "LevelManager.h"
#include "Spawns.h"

u8 currentSpawn = 0;
u8 currentWave = 0;
u8 currentWaveSize = 0;

u16 objectStreamerId = 0;
u16 enemyNumber = 0;
u16 spawnerFrames;
u16 delay = 200;

void ObjectSpawner_Init()
{
    currentWaveSize = sizeof(waves) / sizeof(waves[0]);
    currentSpawn = 0;
    currentWave = 0;
    objectStreamerId = 0;
    enemyNumber = 0;

    spawnerFrames = 0;
    delay = 200;
}

void ObjectSpawner_Update()
{
    if (currentWave < currentWaveSize)
    {
        if (currentSpawn < waves[currentWave].size)
        {
            while (waves[currentWave].spawns[currentSpawn].frame + delay <= spawnerFrames)
            {
                fix16 x = 0;
                fix16 y = 0;
                if (waves[currentWave].spawns[currentSpawn].flags & HORIZONTAL_SECTION_SECTION_0)
                    x = intToFix16(16);
                else if (waves[currentWave].spawns[currentSpawn].flags & HORIZONTAL_SECTION_SECTION_1)
                    x = intToFix16((1 << 5) + 16);
                else if (waves[currentWave].spawns[currentSpawn].flags & HORIZONTAL_SECTION_SECTION_2)
                    x = intToFix16((2 << 5) + 16);
                else if (waves[currentWave].spawns[currentSpawn].flags & HORIZONTAL_SECTION_SECTION_3)
                    x = intToFix16((3 << 5) + 16);
                else if (waves[currentWave].spawns[currentSpawn].flags & HORIZONTAL_SECTION_SECTION_4)
                    x = intToFix16((4 << 5) + 16);
                else if (waves[currentWave].spawns[currentSpawn].flags & HORIZONTAL_SECTION_SECTION_5)
                    x = intToFix16((5 << 5) + 16);
                else if (waves[currentWave].spawns[currentSpawn].flags & HORIZONTAL_SECTION_SECTION_6)
                    x = intToFix16((6 << 5) + 16);
                else if (waves[currentWave].spawns[currentSpawn].flags & HORIZONTAL_SECTION_SECTION_7)
                    x = intToFix16((7 << 5) + 16);

                if (waves[currentWave].spawns[currentSpawn].flags & VERTICAL_SIDE_UP)
                    y = intToFix16(VIRTUAL_SCREEN_HEIGHT);

                ObjectStruct *object = waves[currentWave].spawns[currentSpawn].createObject(x, y);  
                if (object)
                {
                    object->flags = waves[currentWave].spawns[currentSpawn].flags;
                    object->objectStreamerId = objectStreamerId++;
                    enemyNumber++;
                }
                currentSpawn++;
                if(currentSpawn >= currentSpawn < waves[currentWave].size) 
                {  
                    break;
                }
            }
        }
        else if (enemyNumber == 0)
        {
            delay = 0;
            spawnerFrames = 0;
            currentSpawn = 0;
            currentWave++;
        } 
    }
    else
    { 
        //KLog("zerou");
    }
    spawnerFrames++;
}  