﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WaveParser
{
    class Program
    {
        static int
    HORIZONTAL_SECTION_SECTION_0 = 1 << 1,
    HORIZONTAL_SECTION_SECTION_1 = 1 << 2,
    HORIZONTAL_SECTION_SECTION_2 = 1 << 3,
    HORIZONTAL_SECTION_SECTION_3 = 1 << 4,
    HORIZONTAL_SECTION_SECTION_4 = 1 << 5,
    HORIZONTAL_SECTION_SECTION_5 = 1 << 6,
    HORIZONTAL_SECTION_SECTION_6 = 1 << 7,
    HORIZONTAL_SECTION_SECTION_7 = 1 << 8;

        static int
            VERTICAL_SIDE_UP = 1 << 9,
            VERTICAL_SIDE_DOWN = 1 << 10;
        static int
            PATH_STRAIGHT = 1 << 11,
            PATH_FLEE = 1 << 12,
            PATH_FOLLOW = 1 << 13;
        static int
            BULLET_PATH_STRAIGHT = 1 << 14,
            BULLET_PATH_FOLLOW = 1 << 15;


        public class Wave
        {
            public enum ENEMY_TYPE
            {
                ENEMY_TYPE_SMALL, ENEMY_TYPE_MEDIUM, ENEMY_TYPE_LARGE
            }

            public ENEMY_TYPE enemyType;
            public int step;
            public int flags;

            public Wave(
             ENEMY_TYPE enemyType,
             int step,
             int flags)
            {
                this.enemyType = enemyType;
                this.step = step;
                this.flags = flags;
            }
        }

        public class BigWave
        {
            public List<Wave> waves;
        }

        static List<BigWave> bigWaves = new List<BigWave>()
        {
            //WAVE 1
            new BigWave
            {
                waves = new List<Wave>(){
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_MEDIUM, 30, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                },
            },

            //WAVE 2
            new BigWave
            {
                waves = new List<Wave>(){
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_MEDIUM, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_MEDIUM, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),


                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_UP | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_UP | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_UP | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_UP | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                },
            },
                
            //WAVE 3
            new BigWave
            {
                waves = new List<Wave>(){
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_MEDIUM, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_MEDIUM, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_UP | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_UP | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_UP | PATH_FLEE | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_UP | PATH_FLEE | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_3 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FLEE | BULLET_PATH_FOLLOW ),
                },
            },
                
            //WAVE 4
            new BigWave
            {
                waves = new List<Wave>(){
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_LARGE, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_LARGE, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_1 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_5 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_1 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_5 | VERTICAL_SIDE_DOWN | PATH_STRAIGHT | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_1 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_1 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_UP | PATH_FOLLOW | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_UP | PATH_FOLLOW | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_5 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_5 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_UP | PATH_FOLLOW | BULLET_PATH_STRAIGHT ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_UP | PATH_FOLLOW | BULLET_PATH_STRAIGHT ),

                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 200, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 30, HORIZONTAL_SECTION_SECTION_2 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                    new Wave(Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL, 0, HORIZONTAL_SECTION_SECTION_4 | VERTICAL_SIDE_DOWN | PATH_FOLLOW | BULLET_PATH_FOLLOW ),
                },
            },
        };

        class ResultWave
        {
            public string name;
            public int count;
        }

        static void Main(string[] args)
        {
            string text = string.Empty;
            List<ResultWave> resultWaves = new List<ResultWave>();

            for (int j = 0; j < bigWaves.Count; j++)
            {
                var waves = bigWaves[j].waves;
                int waveFrame = 0;
                string spawnName = "spawns" + (j + "").PadLeft(3, '0');
                text += "SpawnStruct const " + spawnName + "[" + waves.Count + "]={\r\n";
                ResultWave resultWave = new ResultWave();
                resultWave.name = spawnName;
                resultWave.count = waves.Count;
                resultWaves.Add(resultWave);
                for (int i = 0; i < waves.Count; i++)
                {
                    waveFrame += waves[i].step;
                    string cons = string.Empty;
                    switch (waves[i].enemyType)
                    {
                        case Wave.ENEMY_TYPE.ENEMY_TYPE_SMALL:
                            cons = "Enemy1Create";
                            break;
                        case Wave.ENEMY_TYPE.ENEMY_TYPE_MEDIUM:
                            cons = "Enemy2Create";
                            break;
                        case Wave.ENEMY_TYPE.ENEMY_TYPE_LARGE:
                            cons = "Enemy3Create";
                            break;
                        default:
                            break;
                    }
                    text += string.Format("{{{0},{1},{2}}}", waveFrame, cons, waves[i].flags);
                    text += ",\r\n";
                }

                text += "};\r\n\r\n";
            }
            text += "WaveStruct const waves[" + bigWaves.Count + "] = {\r\n";
            foreach (var resultWave in resultWaves)
            {
                text += "{&" + resultWave.name + "," + resultWave.count + "},\r\n";
            }
            text += "};\r\n";

            //Debug.WriteLine("#ifndef SPAWNS_INCLUDE_H\r\n#define SPAWNS_INCLUDE_H\r\n#include \"Spawn.h\"\r\n\r\n"+text+"#endif");
            File.WriteAllText("../../../../src/Spawns.h", "#ifndef SPAWNS_INCLUDE_H\r\n#define SPAWNS_INCLUDE_H\r\n#include \"Spawn.h\"\r\n\r\n" + text + "#endif");
        }
    }
}
